#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#


__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_i18n.interfaces import II18n
from zope.intid.interfaces import IIntIds

# import packages
from pyams_utils.registry import get_utility
from pyramid.response import Response
from pyramid.view import view_config
from pyramid_es import get_client


@view_config(name='test-es.json', renderer='string')
def es_test_view(context, request):

    def get_response():
        client = get_client(request)
        # query = client.query() \
        #               .filter_term('title.fr', 'breve') \
        #               .add_term_aggregate('status', 'workflow.status') \
        #               .size(100)
        # return query.execute(fields=['title.fr']).raw

        query = client.query() \
                      .filter_term('_type', 'WfNewsEvent') \
                      .filter_terms('workflow.status', ['published', 'retiring']) \
                      .add_term_aggregate('status', 'workflow.status') \
                      .add_date_aggregate('wf_date', 'workflow.date') \
                      .size(100)
        intids = get_utility(IIntIds)
        for result in query.execute(fields=['internal_id']):
            if not result.internal_id:
                continue
            target = intids.queryObject(result.internal_id[0])
            yield II18n(target).query_attribute('title').encode() + b'\n'
        # return pformat(query.execute(fields=['title.fr', 'workflow.status', 'internal_id']).raw)

    return Response(app_iter=get_response())
